module NsGeo
  class GeoLocation < ApplicationRecord
    validates :ip_address, uniqueness: true
    validates_format_of :ip_address, :with => /\A([01]?\d\d?|2[0-4]\d|25[0-5])\.([01]?\d\d?|2[0-4]\d|25[0-5])\.([01]?\d\d?|2[0-4]\d|25[0-5])\.([01]?\d\d?|2[0-4]\d|25[0-5])\z/
    validates :ip_address, :country_code, :country, :city, :latitude, :longitude, presence: true
    validates_length_of :country_code, :is => 2
    validates :latitude , numericality: { greater_than_or_equal_to:  -90, less_than_or_equal_to:  90 }
    validates :longitude, numericality: { greater_than_or_equal_to: -180, less_than_or_equal_to: 180 }
  end
end
