module NsGeo
  class GeoLocationImporter
    require 'csv'

    def self.import
      total = get_count
      t1 = Time.now
      result = read_csv_file
      t2 = Time.now
      delta = t2 - t1
      puts('GeoLocation Import Report:')
      puts("Locations are imported in: #{delta} seconds.")
      puts("Total records: #{total}")
      puts("Saved records: #{result[:saved]}")
      puts("Discarded records: #{result[:discarded]}")
    end

    def self.get_count
      CSV.foreach(NsGeo.csv_location, :headers => true).count
    end

    def self.read_csv_file
      result = {saved: 0, discarded: 0}
      CSV.foreach(NsGeo.csv_location, :headers => true) do |row|
        if save(row)
          result[:saved] = result[:saved] + 1
        else
          result[:discarded] = result[:discarded] + 1
        end
        unless Rails.env.production?
          if result[:saved] == 1000
            return result
          end
        end
      end
      result
    end

    def self.save(row)
      geo_location = NsGeo::GeoLocation.new
      geo_location[:ip_address] = row[0]
      geo_location[:country_code] = row[1]
      geo_location[:country] = row[2]
      geo_location[:city] = row[3]
      geo_location[:latitude] = row[4]
      geo_location[:longitude] = row[5]
      geo_location[:mystery_value] = row[6]
      geo_location.save
    end
  end
end